Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phystokenc.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phystokenc.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phystokenc.F	(revision 634)
@@ -13,5 +13,6 @@
       USE ioipsl
       USE histcom
-
+      USE dimphy
+      USE iophy
       IMPLICIT none
 
@@ -23,5 +24,5 @@
 c======================================================================
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "tracstoke.h"
 #include "indicesol.h"
@@ -54,5 +55,6 @@
       REAL pen_d(klon,klev) ! flux entraine dans le panache descendant
       REAL pde_d(klon,klev) ! flux detraine dans le panache descendant
-	real pt(klon,klev),t(klon,klev)
+      real pt(klon,klev)
+      REAL,allocatable,save :: t(:,:)
 c
       REAL rlon(klon), rlat(klon), dtime
@@ -71,6 +73,7 @@
 	real fm_therm1(klon,klev)
       REAL pentr_therm(klon,klev)
-      REAL entr_therm(klon,klev)
-      REAL fm_therm(klon,klev)
+    
+      REAL,allocatable,save :: entr_therm(:,:)
+      REAL,allocatable,save :: fm_therm(:,:)
 c
 c   Lessivage:
@@ -88,14 +91,17 @@
       INTEGER i, k
 c
-      REAL mfu(klon,klev)  ! flux de masse dans le panache montant
-      REAL mfd(klon,klev)  ! flux de masse dans le panache descendant
-      REAL en_u(klon,klev) ! flux entraine dans le panache montant
-      REAL de_u(klon,klev) ! flux detraine dans le panache montant
-      REAL en_d(klon,klev) ! flux entraine dans le panache descendant
-      REAL de_d(klon,klev) ! flux detraine dans le panache descendant
-      REAL coefh(klon,klev) ! flux detraine dans le panache descendant
-
-      REAL pyu1(klon),pyv1(klon)
-      REAL pftsol(klon,nbsrf),ppsrf(klon,nbsrf)
+      REAL,allocatable,save :: mfu(:,:)  ! flux de masse dans le panache montant
+      REAL,allocatable,save :: mfd(:,:)  ! flux de masse dans le panache descendant
+      REAL,allocatable,save :: en_u(:,:) ! flux entraine dans le panache montant
+      REAL,allocatable,save :: de_u(:,:) ! flux detraine dans le panache montant
+      REAL,allocatable,save :: en_d(:,:) ! flux entraine dans le panache descendant
+      REAL,allocatable,save :: de_d(:,:) ! flux detraine dans le panache descendant
+      REAL,allocatable,save :: coefh(:,:) ! flux detraine dans le panache descendant
+
+      REAL,allocatable,save :: pyu1(:)
+      REAL,allocatable,save :: pyv1(:)
+      REAL,allocatable,save :: pftsol(:,:)
+      REAL,allocatable,save :: ppsrf(:,:)
+
       real pftsol1(klon),pftsol2(klon),pftsol3(klon),pftsol4(klon)
       real ppsrf1(klon),ppsrf2(klon),ppsrf3(klon),ppsrf4(klon)
@@ -107,10 +113,9 @@
       logical ok_sync
  
-      save t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,dtcum
-	save fm_therm,entr_therm
+      save dtcum
       save iadvtr,irec
-      save pyu1,pyv1,pftsol,ppsrf
 
       data iadvtr,irec/0,1/
+      logical,save :: first=.true.
 c
 c   Couche limite:
@@ -123,4 +128,24 @@
       print*,'istdyn= ',istdyn
 
+      if (first) then
+      
+        allocate( t(klon,klev))
+        allocate( mfu(klon,klev))  
+        allocate( mfd(klon,klev))  
+        allocate( en_u(klon,klev)) 
+        allocate( de_u(klon,klev)) 
+        allocate( en_d(klon,klev)) 
+        allocate( de_d(klon,klev)) 
+        allocate( coefh(klon,klev)) 
+        allocate( entr_therm(klon,klev))
+        allocate( fm_therm(klon,klev))
+        allocate( pyu1(klon))
+        allocate( pyv1(klon))
+        allocate( pftsol(klon,nbsrf))
+        allocate( ppsrf(klon,nbsrf))
+  
+        first=.false.
+      endif
+      
       IF (iadvtr.eq.0) THEN
 	
@@ -136,10 +161,10 @@
       ndex3d = 0
       i=itap 
-      CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
-      CALL histwrite(physid,"phis",i,zx_tmp_2d,iim*(jjm+1),ndex2d)
+cym      CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
+      CALL histwrite_phy(physid,"phis",i,pphis)
 c
       i=itap
-      CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
-      CALL histwrite(physid,"aire",i,zx_tmp_2d,iim*(jjm+1),ndex2d)
+cym      CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
+      CALL histwrite_phy(physid,"aire",i,paire)
 
       iadvtr=iadvtr+1
@@ -247,29 +272,21 @@
 
 ccccc
-         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, t, zx_tmp_3d)
-         CALL histwrite(physid,"t",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex3d)
-
-         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfu, zx_tmp_3d)
-      CALL histwrite(physid,"mfu",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex3d)
-	CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfd, zx_tmp_3d)
-      CALL histwrite(physid,"mfd",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex3d)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_u, zx_tmp_3d)
-      CALL histwrite(physid,"en_u",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex3d)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_u, zx_tmp_3d)
-      CALL histwrite(physid,"de_u",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex3d)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_d, zx_tmp_3d)
-      CALL histwrite(physid,"en_d",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex3d)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_d, zx_tmp_3d)       
-      CALL histwrite(physid,"de_d",itap,zx_tmp_3d,    
-     .                                   iim*(jjm+1)*klev,ndex3d)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, coefh, zx_tmp_3d)         
-      CALL histwrite(physid,"coefh",itap,zx_tmp_3d,    
-     .                                   iim*(jjm+1)*klev,ndex3d)	
+cym         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, t, zx_tmp_3d)
+         CALL histwrite_phy(physid,"t",itap,t)
+
+cym         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfu, zx_tmp_3d)
+      CALL histwrite_phy(physid,"mfu",itap,mfu)
+cym	CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfd, zx_tmp_3d)
+      CALL histwrite_phy(physid,"mfd",itap,mfd)
+cym        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_u, zx_tmp_3d)
+      CALL histwrite_phy(physid,"en_u",itap,en_u)
+cym        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_u, zx_tmp_3d)
+      CALL histwrite_phy(physid,"de_u",itap,de_u)
+cym        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_d, zx_tmp_3d)
+      CALL histwrite_phy(physid,"en_d",itap,en_d)
+cym        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_d, zx_tmp_3d)       
+      CALL histwrite_phy(physid,"de_d",itap,de_d)
+cym        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, coefh, zx_tmp_3d)         
+      CALL histwrite_phy(physid,"coefh",itap,coefh)	
 
 c ajou...
@@ -280,53 +297,39 @@
 	enddo
 
-      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, fm_therm1, zx_tmp_3d)
-      CALL histwrite(physid,"fm_th",itap,zx_tmp_3d,
-     .                                 iim*(jjm+1)*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, entr_therm, zx_tmp_3d)
-      CALL histwrite(physid,"en_th",itap,zx_tmp_3d,
-     .                                iim*(jjm+1)*klev,ndex3d)
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, fm_therm1, zx_tmp_3d)
+      CALL histwrite_phy(physid,"fm_th",itap,fm_therm1)
+c
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, entr_therm, zx_tmp_3d)
+      CALL histwrite_phy(physid,"en_th",itap,entr_therm)
 cccc
-       CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_impa,zx_tmp_3d)
-        CALL histwrite(physid,"frac_impa",itap,zx_tmp_3d,
-     .  iim*(jjm+1)*klev,ndex3d)
-
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_nucl,zx_tmp_3d)
-        CALL histwrite(physid,"frac_nucl",itap,zx_tmp_3d,
-     .  iim*(jjm+1)*klev,ndex3d)
+cym       CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_impa,zx_tmp_3d)
+        CALL histwrite_phy(physid,"frac_impa",itap,frac_impa)
+
+cym        CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_nucl,zx_tmp_3d)
+        CALL histwrite_phy(physid,"frac_nucl",itap,frac_nucl)
  
-        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyu1,zx_tmp_2d)
-      CALL histwrite(physid,"pyu1",itap,zx_tmp_2d,iim*(jjm+1),
-     .                                                ndex2d)
+cym        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyu1,zx_tmp_2d)
+      CALL histwrite_phy(physid,"pyu1",itap,pyu1)
 	
-	CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyv1,zx_tmp_2d)
-      CALL histwrite(physid,"pyv1",itap,zx_tmp_2d,iim*(jjm+1)
-     .                                                ,ndex2d)
+cym	CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyv1,zx_tmp_2d)
+      CALL histwrite_phy(physid,"pyv1",itap,pyv1)
 	
-	CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol1, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol1",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol2, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol2",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
-          CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol3, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol3",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol4, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol4",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf1, zx_tmp_2d)
-      CALL histwrite(physid,"psrf1",itap,zx_tmp_2d,   
-     .                                   iim*(jjm+1),ndex2d)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf2, zx_tmp_2d)
-      CALL histwrite(physid,"psrf2",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf3, zx_tmp_2d)
-      CALL histwrite(physid,"psrf3",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf4, zx_tmp_2d)
-      CALL histwrite(physid,"psrf4",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex2d)
+cym	CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol1, zx_tmp_2d)
+      CALL histwrite_phy(physid,"ftsol1",itap,pftsol1)
+cym         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol2, zx_tmp_2d)
+      CALL histwrite_phy(physid,"ftsol2",itap,pftsol2)
+cym          CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol3, zx_tmp_2d)
+      CALL histwrite_phy(physid,"ftsol3",itap,pftsol3)
+cym         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol4, zx_tmp_2d)
+      CALL histwrite_phy(physid,"ftsol4",itap,pftsol4)
+
+cym        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf1, zx_tmp_2d)
+      CALL histwrite_phy(physid,"psrf1",itap,ppsrf1)
+cym        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf2, zx_tmp_2d)
+      CALL histwrite_phy(physid,"psrf2",itap,ppsrf2)
+cym        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf3, zx_tmp_2d)
+      CALL histwrite_phy(physid,"psrf3",itap,ppsrf3)
+cym        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf4, zx_tmp_2d)
+      CALL histwrite_phy(physid,"psrf4",itap,ppsrf4)
 
       if (ok_sync) call histsync(physid)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phytrac.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phytrac.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/phytrac.F	(revision 634)
@@ -64,5 +64,10 @@
 
       USE ioipsl
-
+      USE dimphy
+      USE comgeomphy
+      USE iophy
+#ifdef CPP_PARALLEL
+      USE vampir
+#endif
 #ifdef INCA
       USE sflx
@@ -76,4 +81,7 @@
 #ifdef INCA_AER
       USE AEROSOL_MOD, only : ntr,trmx,trnx
+cym      USE AEROSOL_DIAG, only : cla,las,tausum,angst,aload,scon
+cym     .                            ,scavcoef_st,scavcoef_cv
+cym      USE AEROSOL_PROGNOS, ONLY : md
       USE AEROSOL_DIAG,only : cla,las,tausum,angst,aload,cload,totaerh2o,tau,
      $  emiss20,sconc,scavcoef_st,scavcoef_cv
@@ -103,10 +111,10 @@
 #include "YOMCST.h"
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
 #include "indicesol.h"
 #include "temps.h"
 #include "paramet.h"
 #include "control.h"
-#include "comgeomphy.h"
+cym#include "comgeomphy.h"
 #include "advtrac.h"
 c======================================================================
@@ -225,21 +233,22 @@
 cAA ................................................
  
-      REAL trs(klon,nbtr)    ! Conc. radon ds le sol
-      SAVE trs
-
-      REAL masktr(klon,nbtr) ! Masque reservoir de sol traceur
+      REAL,save,allocatable :: trs(:,:)    ! Conc. radon ds le sol
+cym      SAVE trs
+      REAL :: trs_tmp(klon2)
+      
+      REAL,save,allocatable :: masktr(:,:) ! Masque reservoir de sol traceur
 c                            Masque de l'echange avec la surface
 c                           (1 = reservoir) ou (possible => 1 )
-      SAVE masktr
-      REAL fshtr(klon,nbtr)  ! Flux surfacique dans le reservoir de sol
-      SAVE fshtr
-      REAL hsoltr(nbtr)      ! Epaisseur equivalente du reservoir de sol
-      SAVE hsoltr
-      REAL tautr(nbtr)       ! Constante de decroissance radioactive
-      SAVE tautr
-      REAL vdeptr(nbtr)      ! Vitesse de depot sec dans la couche Brownienne
-      SAVE vdeptr
-      REAL scavtr(nbtr)      ! Coefficient de lessivage
-      SAVE scavtr
+cym      SAVE masktr
+      REAL,save,allocatable :: fshtr(:,:)  ! Flux surfacique dans le reservoir de sol
+cym      SAVE fshtr
+      REAL,save,allocatable :: hsoltr(:)      ! Epaisseur equivalente du reservoir de sol
+cym      SAVE hsoltr
+      REAL,save,allocatable :: tautr(:)       ! Constante de decroissance radioactive
+cym      SAVE tautr
+      REAL,save,allocatable :: vdeptr(:)      ! Vitesse de depot sec dans la couche Brownienne
+cym      SAVE vdeptr
+      REAL,save,allocatable :: scavtr(:)      ! Coefficient de lessivage
+cym      SAVE scavtr
 cAA
       CHARACTER*2 itn
@@ -273,11 +282,11 @@
 C nature du traceur
 c
-      logical aerosol(nbtr)  ! Nature du traceur
+      logical,save,allocatable :: aerosol(:)  ! Nature du traceur
 c                            ! aerosol(it) = true  => aerosol 
 c                            ! aerosol(it) = false => gaz 
 c                            ! nat_trac(it) = 1. aerosol
-      logical clsol(nbtr)    ! clsol(it) = true => CL sol calculee
-      logical radio(nbtr)    ! radio(it)=true => decroisssance radioactive
-      save aerosol,clsol,radio
+      logical,save,allocatable :: clsol(:)    ! clsol(it) = true => CL sol calculee
+      logical,save,allocatable :: radio(:)    ! radio(it)=true => decroisssance radioactive
+cym      save aerosol,clsol,radio
 C
 c======================================================================
@@ -298,5 +307,7 @@
       REAL d_tr(klon,klev), d_trs(klon) ! tendances de traceurs 
       REAL d_tr_cl(klon,klev,nbtr) ! tendance de traceurs  couche limite
-      REAL d_tr_cv(klon,klev,nbtr) ! tendance de traceurs  conv pour chq traceur
+      REAL d_tr_cli(klon,klev,nbtr) ! tendance de traceurs  CL pour chq traceur
+      REAL d_tr_cv(klon,klev,nbtr) ! tendance de traceurs  convection
+      REAL d_tr_cvi(klon,klev,nbtr) ! tendance de traceurs  conv pour chq traceur
       REAL d_tr_th(klon,klev,nbtr) ! la tendance des thermiques
       REAL d_tr_dec(klon,klev,nbtr) ! la tendance de la decroissance 
@@ -367,15 +378,5 @@
 #endif
      .                                         /)
-
-
-      REAL, PARAMETER   :: dry_mass = 28.966
-      REAL, POINTER     :: hbuf(:)
-      REAL, ALLOCATABLE :: obuf(:)
-      REAL              :: calday
-      REAL              :: pdel(klon,klev)
-      REAL              :: dummy(klon,klev) = 0.
-#endif
-#ifdef INCA_AER
-      integer la
+      dummy(:,:)=0.
 #endif
 c
@@ -386,4 +387,14 @@
 
          if (debutphy) then
+           allocate( trs(klon,nbtr) )  
+           allocate( masktr(klon,nbtr)) 
+           allocate( fshtr(klon,nbtr) )
+           allocate( hsoltr(nbtr))
+           allocate( tautr(nbtr))
+           allocate( vdeptr(nbtr))
+           allocate( scavtr(nbtr))
+           allocate( aerosol(nbtr))
+           allocate( clsol(nbtr))
+           allocate( radio(nbtr))
 
           ecrit_tra = NINT(86400./pdtphys *ecritphy) 
@@ -416,9 +427,13 @@
 c        print*,'valeur de debut dans phytrac :',debutphy
          trs(:,:) = 0.
-
-         open (99,file='starttrac',status='old',
+         
+       if (phy_rank==0) then
+         trs_tmp(:)=0.
+	 open (99,file='starttrac',status='old',
      .         err=999,form='formatted')
-         read(99,*) (trs(i,1),i=1,klon)
+         read(99,*) (trs_tmp(i),i=1,klon2)
 999      close(99)
+       endif
+       call ScatterField(trs_tmp,trs(:,1),1)
 c         print*, 'apres starttrac'
 
@@ -451,4 +466,6 @@
       endif
 #ifdef INCA
+      call VTe(VTphysiq)
+      call VTb(VTinca)
 !======================================================================
 !     Chimie
@@ -539,4 +556,6 @@
       END DO
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #else
 
@@ -861,10 +880,15 @@
       if (lafin) then
          print*, 'c est la fin de la physique'
-         open (99,file='restarttrac',  form='formatted')
-         do i=1,klon
-             write(99,*) trs(i,1)
-         enddo
-         PRINT*, 'Ecriture du fichier restarttrac'
-         close(99)
+	 
+	 call GatherField(trs(:,1),trs_tmp,1)
+	 if (phy_rank==0) then
+         
+	   open (99,file='restarttrac',  form='formatted')
+           do i=1,klon
+               write(99,*) trs_tmp(i)
+           enddo
+           PRINT*, 'Ecriture du fichier restarttrac'
+           close(99)
+	 endif
       else
          print*, 'physique pas fini'
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/raddim.h
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/raddim.h	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/raddim.h	(revision 634)
@@ -1,5 +1,5 @@
 !
-! $Header $
+! $Header$
 !
       INTEGER kdlon, kflev
-      PARAMETER (kdlon=klon,kflev=klev)
+      PARAMETER (kdlon=149,kflev=klev)
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radiornpb.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radiornpb.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radiornpb.F	(revision 634)
@@ -3,4 +3,5 @@
 !
       SUBROUTINE radiornpb(tr,dtime,tautr,d_tr) 
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -12,6 +13,6 @@
 c Arguments:
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 c======================================================================
 C
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radlwsw.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radlwsw.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/radlwsw.F	(revision 634)
@@ -16,4 +16,5 @@
      .                  cldtaupi, topswai, solswai)
 c      
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -69,7 +70,7 @@
       
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "YOETHF.h"
 c
@@ -428,10 +429,10 @@
      S              PTOPSWAD,PSOLSWAD,PTOPSWAI,PSOLSWAI,
      J              ok_ade, ok_aie )
-      
+      USE dimphy      
       IMPLICIT none
 
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "YOMCST.h"
 C
@@ -547,10 +548,10 @@
       REAL*8 PSOLSWAI(KDLON)     ! SHORTWAVE FLUX AT SURFACE(+AEROSOL IND)
 cjq - Fluxes including aerosol effects
-      REAL*8 ZFSUPAD(KDLON,KFLEV+1)
-      REAL*8 ZFSDNAD(KDLON,KFLEV+1)
-      REAL*8 ZFSUPAI(KDLON,KFLEV+1)
-      REAL*8 ZFSDNAI(KDLON,KFLEV+1)
+      REAL*8,allocatable,save :: ZFSUPAD(:,:)
+      REAL*8,allocatable,save :: ZFSDNAD(:,:)
+      REAL*8,allocatable,save :: ZFSUPAI(:,:)
+      REAL*8,allocatable,save :: ZFSDNAI(:,:)
       logical initialized
-      SAVE ZFSUPAD, ZFSDNAD, ZFSUPAI, ZFSDNAI ! aerosol fluxes
+cym      SAVE ZFSUPAD, ZFSDNAD, ZFSUPAI, ZFSDNAI ! aerosol fluxes
 !rv
       save flag_aer
@@ -560,4 +561,13 @@
         flag_aer=0.
         initialized=.TRUE.
+        allocate(ZFSUPAD(KDLON,KFLEV+1))
+        allocate(ZFSDNAD(KDLON,KFLEV+1))
+        allocate(ZFSUPAI(KDLON,KFLEV+1))
+        allocate(ZFSDNAI(KDLON,KFLEV+1))
+	ZFSUPAD(:,:)=0.
+        ZFSDNAD(:,:)=0.
+        ZFSUPAI(:,:)=0.
+        ZFSDNAI(:,:)=0.
+	
       endif
 !rv
@@ -735,8 +745,9 @@
      S                PTAVE,PWV,PAKI,PCLD,PCLEAR,PDSIG,PFACT,
      S                PRMU,PSEC,PUD)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "radepsi.h"
 #include "radopt.h"
@@ -925,8 +936,9 @@
      S  ,  PDSIG , POMEGA, POZ  , PRMU , PSEC , PTAU  , PUD  
      S  ,  PFD   , PFU)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 C
 C     ------------------------------------------------------------------
@@ -1165,8 +1177,9 @@
      S  ,  PUD   ,PWV , PQS
      S  ,  PFDOWN,PFUP                                            )
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "radepsi.h"
 C
@@ -1711,8 +1724,9 @@
      S  , PCGAZ , PPIZAZ, PRAY1 , PRAY2 , PREFZ , PRJ  
      S  , PRK   , PRMU0 , PTAUAZ, PTRA1 , PTRA2                   )
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "radepsi.h"
 #include "radopt.h"
@@ -2071,8 +2085,9 @@
      S  , PCGAZ , PPIZAZ, PRAY1, PRAY2, PREFZ , PRJ  , PRK , PRMUE
      S  , PTAUAZ, PTRA1 , PTRA2 )
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "radepsi.h"
 #include "radopt.h"
@@ -2427,8 +2442,9 @@
       SUBROUTINE SWDE (PGG,PREF,PRMUZ,PTO1,PW,
      S                 PRE1,PRE2,PTR1,PTR2)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 C
 C     ------------------------------------------------------------------
@@ -2558,8 +2574,9 @@
       END
       SUBROUTINE SWTT (KNU,KA,PU,PTR)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 C
 C-----------------------------------------------------------------------
@@ -2674,8 +2691,9 @@
       END
       SUBROUTINE SWTT1(KNU,KABS,KIND, PU, PTR)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 C
 C-----------------------------------------------------------------------
@@ -2806,8 +2824,9 @@
 cIM  .              ptoplwdown,ptoplwdownclr)
      .              plwup, plwdn, plwup0, plwdn0)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 #include "YOMCST.h"
@@ -2884,11 +2903,17 @@
       REAL*8 ZOZ(KDLON,KFLEV)
 c
-      REAL*8 ZFLUX(KDLON,2,KFLEV+1) ! RADIATIVE FLUXES (1:up; 2:down)
-      REAL*8 ZFLUC(KDLON,2,KFLEV+1) ! CLEAR-SKY RADIATIVE FLUXES
-      REAL*8 ZBINT(KDLON,KFLEV+1)            ! Intermediate variable
-      REAL*8 ZBSUI(KDLON)                    ! Intermediate variable
-      REAL*8 ZCTS(KDLON,KFLEV)               ! Intermediate variable
-      REAL*8 ZCNTRB(KDLON,KFLEV+1,KFLEV+1)   ! Intermediate variable
-      SAVE ZFLUX, ZFLUC, ZBINT, ZBSUI, ZCTS, ZCNTRB
+cym      REAL*8 ZFLUX(KDLON,2,KFLEV+1) ! RADIATIVE FLUXES (1:up; 2:down)
+cym      REAL*8 ZFLUC(KDLON,2,KFLEV+1) ! CLEAR-SKY RADIATIVE FLUXES
+cym      REAL*8 ZBINT(KDLON,KFLEV+1)            ! Intermediate variable
+cym      REAL*8 ZBSUI(KDLON)                    ! Intermediate variable
+cym      REAL*8,ZCTS(KDLON,KFLEV)               ! Intermediate variable
+cym      REAL*8 ZCNTRB(KDLON,KFLEV+1,KFLEV+1)   ! Intermediate variable
+cym      SAVE ZFLUX, ZFLUC, ZBINT, ZBSUI, ZCTS, ZCNTRB
+      REAL*8,allocatable,save :: ZFLUX(:,:,:) ! RADIATIVE FLUXES (1:up; 2:down)
+      REAL*8,allocatable,save :: ZFLUC(:,:,:) ! CLEAR-SKY RADIATIVE FLUXES
+      REAL*8,allocatable,save :: ZBINT(:,:)            ! Intermediate variable
+      REAL*8,allocatable,save :: ZBSUI(:)                    ! Intermediate variable
+      REAL*8,allocatable,save :: ZCTS(:,:)               ! Intermediate variable
+      REAL*8,allocatable,save :: ZCNTRB(:,:,:)   ! Intermediate variable
 c
       INTEGER ilim, i, k, kpl1
@@ -2909,4 +2934,11 @@
          PRINT*, "LW cloudy-sky calling frequency: ", lwpas
          PRINT*, "   In general, they should be 1"
+cym
+	 allocate(ZFLUX(KDLON,2,KFLEV+1) )
+         allocate(ZFLUC(KDLON,2,KFLEV+1) )
+         allocate(ZBINT(KDLON,KFLEV+1))
+         allocate(ZBSUI(KDLON))
+         allocate(ZCTS(KDLON,KFLEV))
+         allocate(ZCNTRB(KDLON,KFLEV+1,KFLEV+1))
          appel1er=.FALSE.
       ENDIF
@@ -2973,8 +3005,9 @@
      S               PAER,PDP,PPMB,PPSOL,POZ,PTAVE,PVIEW,PWV,
      S               PABCU)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 #include "YOMCST.h"
@@ -3366,8 +3399,9 @@
       SUBROUTINE LWBV(KLIM,PDP,PDT0,PEMIS,PPMB,PTL,PTAVE,PABCU,
      S                PFLUC,PBINT,PBSUI,PCTS,PCNTRB)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 #include "YOMCST.h"
@@ -3457,8 +3491,9 @@
      R               PBINT,PBSUIN,PCTS,PCNTRB,
      S               PFLUX)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "radepsi.h"
 #include "radopt.h"
@@ -3862,8 +3897,9 @@
      S  , PB,PBINT,PBSUIN,PBSUR,PBTOP,PDBSL
      S  , PGA,PGB,PGASUR,PGBSUR,PGATOP,PGBTOP)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 C
@@ -5273,8 +5309,9 @@
      R  , PGA,PGB,PGASUR,PGBSUR,PGATOP,PGBTOP
      S  , PCNTRB,PCTS,PFLUC)
+       USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 #include "YOMCST.h"
@@ -5386,8 +5423,9 @@
      R  , PGA,PGB,PGASUR,PGBSUR,PGATOP,PGBTOP
      S  , PCTS,PFLUC)
+       USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 #include "radopt.h"
@@ -5718,8 +5756,9 @@
      R  , PGA,PGB
      S  , PCNTRB,PDISD,PDISU)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 C
@@ -5970,8 +6009,9 @@
      R  , PABCU,PDBSL,PGA,PGB
      S  , PADJD,PADJU,PCNTRB,PDBDT)
+       USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 C
@@ -6177,8 +6217,9 @@
       END
       SUBROUTINE LWTT(PGA,PGB,PUU, PTT)
+       USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 C
@@ -6352,8 +6393,9 @@
       END
       SUBROUTINE LWTTM(PGA,PGB,PUU1,PUU2, PTT)
+      USE dimphy
       IMPLICIT none
-#include "dimensions.h"
-#include "dimphy.h"
-#include "raddim.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "raddim.h"
 #include "raddimlw.h"
 C
